const {GateDevice, Directions} = require('@stargate-system/device');

let timer;
let filename;

GateDevice.setName('Recorder');
const setpoint = GateDevice.factory.createInteger(Directions.input);
setpoint.valueName = 'Setpoint';
const temperature = GateDevice.factory.createInteger(Directions.input);
temperature.valueName = 'Temperature';
const startSwitch = GateDevice.factory.createBoolean(Directions.input);
startSwitch.valueName = 'Record';
startSwitch.onRemoteUpdate = () => {
    if (startSwitch.value) {
        filename = `${Date.now()}.csv`;
        timer = setInterval(() => {
            GateDevice.ServerStorage.append(filename, `${Date.now()},${setpoint.value},${temperature.value}\n`, '/data');
        }, 3000);
    } else {
        clearInterval(timer);
    }
}
GateDevice.start();
