const {GateDevice, Directions} = require('@stargate-system/device');
const controller = require('./src/controller');
const model = require('./src/model');

GateDevice.setName('Temperature regulator');

model.setpoint = GateDevice.factory.createInteger(Directions.input);
model.setpoint.valueName = 'Setpoint';

model.temperature = GateDevice.factory.createInteger(Directions.input);
model.temperature.valueName = 'Temperature';

model.power = GateDevice.factory.createInteger(Directions.output);
model.power.valueName = 'Power';
model.power.setRange([0, 100]);

model.startSwitch = GateDevice.factory.createBoolean(Directions.input);
model.startSwitch.valueName = 'Start/Stop';

controller.init();
GateDevice.start();
