const config = require('../config');

const interval = config.measurementInterval;
const buffer = [];
let slope = 0;

const calculateSlope = () => {
    const time = [];
    const averageValue = buffer.reduce((a, b) => a + b)/buffer.length;
    const averageTime = (buffer.length - 1) * interval / 2;
    for (let i = 0; i < buffer.length; i++) {
        time.push(i * interval);
    }
    let factorDenominator = 0;
    time.forEach((value) => factorDenominator += Math.pow(value - averageTime, 2));
    let factorNumerator = 0;
    buffer.forEach((value, index) => {
        const currentTime = time[index];
        factorNumerator += (currentTime - averageTime) * (value - averageValue);
    });
    slope = factorNumerator / factorDenominator;
}

const add = (currentValue) => {
    buffer.push(currentValue);
    if (buffer.length > 10) {
        buffer.shift();
    }
    if (buffer.length > 3) {
        calculateSlope();
    }
}

const getSlope = () => {
    return slope;
}

module.exports = {
    add,
    getSlope
}