const model = require('./model');
const buffer = require('./dataBuffer');
const config = require('../config');

let cutoffTemperature;

const setCutoff = () => {
    cutoffTemperature = config.cutOffThreshold * (model.setpoint.value - model.temperature.value) + model.temperature.value;
    model.power.setValue(100);
}

const start = () => {
    setCutoff();
}

const adjust = () => {
    if (cutoffTemperature !== undefined) {
        if (model.temperature.value > cutoffTemperature) {
            model.power.setValue(0);
            cutoffTemperature = undefined;
        }
    } else {
        if (buffer.getSlope() < config.stableSlope) {
            setCutoff();
        }
    }
}

module.exports = {
    start,
    adjust
}